package cn.com.infosec.asn1;

import java.io.ByteArrayOutputStream;
import java.util.Enumeration;

public class DERSet extends ASN1Set {
   public DERSet() {
   }

   public DERSet(DEREncodable obj) {
      this.addObject(obj);
   }

   public DERSet(DEREncodableVector v) {
      this(v, true);
   }

   public DERSet(ASN1Encodable[] a) {
      for(int var2 = 0; var2 != a.length; ++var2) {
         this.addObject(a[var2]);
      }

      this.sort();
   }

   DERSet(DEREncodableVector v, boolean needsSorting) {
      for(int var3 = 0; var3 != v.size(); ++var3) {
         this.addObject(v.get(var3));
      }

      if (needsSorting) {
         this.sort();
      }

   }

   void encode(DEROutputStream out) {
      DERSet var10000 = this;
      ByteArrayOutputStream var4;
      var4 = new ByteArrayOutputStream.<init>();
      DEROutputStream var2;
      var2 = new DEROutputStream.<init>(var4);
      Enumeration var3 = var10000.getObjects();

      while(var3.hasMoreElements()) {
         var2.writeObject(var3.nextElement());
      }

      var2.close();
      out.writeEncoded(49, var4.toByteArray());
   }
}
